﻿
#load "References.fsx"

open System.Text.RegularExpressions

let convert (str: String) : String =
  let replaceArrs (s: Match) = Regex.Replace (s.Value, "->", "=")
  Regex.Replace (str, "%BEGING[^%]+%ENDG", MatchEvaluator(replaceArrs))

let dir = @"C:\Users\steven\SkyDrive\Projects\HORSBenchmarks\GTRecS"
let files = System.IO.Directory.GetFiles (dir, "*.hrs")
for file in files do
  let str = System.IO.File.ReadAllText file
  let res = convert str
  let fileRoot = System.IO.Path.GetFileNameWithoutExtension file
  let newFilePath = System.IO.Path.Combine (dir,  fileRoot + ".hrs")
  System.IO.File.WriteAllText (newFilePath, res)
