﻿module Subtyping

open RecScheme
open BasicTypes
open ModelCheckLib
(*
let rec subtype (s : IntType) (t : IntType) : bool =
    match s, t with 
      Atom q1, Atom q2 when q1 = q2  -> true
    | Union bs, Union bs'            -> bs.IsSubsetOf bs'
    | (Arrow(a, b)), (Arrow(a', b')) -> subtypeSet a' a && subtype b b'
    | Atom  _, Union _
    | Arrow _, Union _
    | Union _, Arrow _
    | Union _, Atom  _
    | Atom  _, Atom  _
    | Atom  _, Arrow _
    | Arrow _, Atom  _               -> false
and
  subtypeSet (ss : IntTypeSet) (ts : IntTypeSet) : bool = 
    Seq.forall (fun x -> Seq.exists (fun y -> subtype y x) ss) ts


let rec mkCanonical (x : IntType) : IntType =
  match x with
    Atom  _ -> x
  | Union _ -> x
  | Arrow (ts, t) -> 
      let rec
        cts = Seq.map mkCanonical ts
        and isDiffSubtype x y = not (Microsoft.FSharp.Core.LanguagePrimitives.PhysicalEquality x y) && subtype x y 
        and neverSubtype types x =
                  Seq.forall (fun y -> not (isDiffSubtype y x)) types
      in 
        Arrow (new HashSet<_>(Seq.filter (neverSubtype cts) cts), mkCanonical t)

let mkCanonical_flat (x : IntType) : IntType =
  match x with
    Atom  _ -> x
  | Union _ -> x
  | Arrow (ts, t) -> 
      let rec
        cts = ts
        and isDiffSubtype x y = not (Microsoft.FSharp.Core.LanguagePrimitives.PhysicalEquality x y) && subtype x y
        and neverSubtype types x =
                  Seq.forall (fun y -> not (isDiffSubtype y x)) types
      in 
        Arrow (new HashSet<_>(Seq.filter (neverSubtype cts) cts), t)
*)

(* Not needed yet
let mkCanonicalSet (ts : IntTypeSet) : IntTypeSet =
  let arrow =
    mkCanonical (Arrow (ts, Atom initialState))
  in
    match arrow with
      Atom _ -> failwith "Error in type canonisation"
    | Arrow (tsp, _) -> tsp

let mkCanonicalEnv (e : NTTypeEnv.t) : NTTypeEnv.t =
  NTTypeEnv.mkTypeEnv (NTTypeEnv.map mkCanonicalSet e)

  *)