﻿#load "Ubiquitous.fs"
#load "Continuation.fs"
#load "List.fs"

let b1 = 
  List.toStringWithDelims "[" "," "]" [1;2;3;4] = "[1,2,3,4]"

let b2 =
  true = List.contains 3 [1;2;3;4]

let b3 =
  false = List.contains "a" ["b"; "c"; "d"]

let b4 =
  true = List.allDifferent [1;2;3;4]

let b5 =
  false = List.allDifferent ["a"; "b"; "a"]

let b6 =
  [1;2;3;4] = List.nub [1;2;2;1;3;4;2]

let b7 = 
  [1;2;3;4] = List.nub [1;2;3;4]

let b8 = 
  [[1;3]; [2;3]; [1;4]; [2;4]] = List.productL [[1;2]; [3;4]]

let b9 = 
  [[1;3;5]; [2;3;5]; [1;4;5]; [2;4;5]; [1;3;6]; [2;3;6]; [1;4;6]; [2;4;6]] = List.productL [[1;2]; [3;4]; [5;6]]