﻿namespace ModelCheckLib

module Cfg =

  let verbose       = ref false
  let printGraph    = ref false
  let timing        = ref false
  let maxrounds     = ref -1
  let certificate   = ref false

  // Enable for extra sanity checks
  // that slow down the algorithm
  let checks        = ref false

  let trivialopt    = ref true
  let order1opt     = ref true
  let canonicalopt  = ref false
  let nodeReifyOpt  = ref false
  let reifyCacheOpt = ref true
  let pruneOpt      = ref false
  let filterOpen    = ref false
  let badnessopt    = ref false
  let leastopensopt = ref false
  let weakopt       = ref true
  let extGameOpt    = ref false