﻿
#I @"..\FSharpLibs\FParsec"
#r @"..\Utils\bin\Debug\Utils.dll"
#r @"..\RecScheme\bin\Debug\RecScheme.dll"
#r "FParsecCS.dll"
#r "FParsec.dll"

#load "TvType.fs"
#load "IntType.fs"
#load "BasicTypes.fs"
#load "RoseTree.fs"
#load "Derivation.fs"
#load "TvMap.fs"
#load "CalD.fs"
#load "TestParsers.fs"

open RecScheme.Testing

let states = ["q"; "o"] @ (List.map (toString >> (+) "q") [0..10])

let pt = TestParsers.IntTypeParser.parse
let pi = TestParsers.indirectType
let pm = TestParsers.tvMap

let m1 = pm "[{q0}; {}; {a0 -> q1;a1 -> q0}; {a2 -> a1 -> q0}]"

let t1 = pi "a3 -> q"

let b1 = TvMap.reify m1 t1
          =
           pt "((Top -> q0) ^ (q0 -> q1) -> Top -> q0) -> q"


let b2 = TvMap.reify m1 (pi "a0 -> a1 -> a2 -> a3 -> q10")
          =
           pt ("q0 -> Top -> (Top -> q0) ^ (q0 -> q1) -> " +
               "((Top -> q0) ^ (q0 -> q1) -> Top -> q0) -> q10")